
/*
DM2RM Station Manager V1.15

July 2017 
Simple Station Manager to select two Microphones, a key and PTT for two Transceiver.
Use left and right button to select

Version 1.14 with EEPROM to save the last settings
  
*/
 
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <EEPROM.h>


LiquidCrystal_I2C lcd(0x27,20,4);
 

 
int txstat = 0;
// 0 default
// 1 all on TX2


int buttonState = 0;

int upbutton = 2;                             //up button 
int downbutton = 3;                            // down button
byte buttonpressed = (0);                       // 0 = no button pressed
int unsigned long ButtonTime = 100;             // Timer button depressed

int Mic1 = 4;  // output pins
int Mic2 = 5;
int Key = 7;
int PTTin = 6;
int AUX = 8;   // for SP, CAT or other 
int Key2 = 9;


// icons 
byte sp[8] = {
	B00011,
	B00101,
	B11001,
	B11001,
	B11001,
	B00101,
	B00011,
	B00000,
};

byte on_left[8] = {
	B00111,
	B01000,
	B10011,
	B10111,
	B10111,
	B10011,
	B01000,
	B00111
};

byte on_right[8] = {
	B11100,
	B00010,
	B11001,
	B11101,
	B11101,
	B11001,
	B00010,
	B11100
};

byte off_left[8] = {
	B00111,
	B01000,
	B10000,
	B10000,
	B10000,
	B10000,
	B01000,
	B00111
};

byte off_right[8] = {
	B11100,
	B00010,
	B00001,
	B00001,
	B00001,
	B00001,
	B00010,
	B11100
};

byte mic[8] = {
	B01110,
	B01110,
	B01110,
	B00100,
	B10001,
	B01110,
	B00100,
	B01110
};

byte key[8] = {
	B10100,
	B11000,
	B10100,
	B00000,
	B00101,
	B00010,
	B00010,
	B00000
};

byte ptt[8] = {
	B11000,
	B11000,
	B10111,
	B00010,
	B00010,
	B11100,
	B01000,
	B01000
};

void setup() {
  
    
   // declare pin 9 to be an output:
  pinMode(Mic1, OUTPUT);              //pin for Mic1
  pinMode(Mic2, OUTPUT);                //pin for Mic2
  pinMode(Key, OUTPUT);                 //pin for Key
  pinMode(PTTin, OUTPUT);               //pin for PTT
  pinMode(AUX, OUTPUT);                 //pin for AUX, SP, CAT, CI-V
  pinMode(Key2, OUTPUT);                //pin for Key2
  
  pinMode(downbutton, INPUT);          //pin for right button  
  pinMode(upbutton, INPUT);           //pin for left button
  
   //LCD display settings
  lcd.init();                            // LCD initializing             
  lcd.backlight();                       // LCD backlight
  
   // set up the LCD's number of columns and rows: 
  lcd.begin(20, 4);
  lcd.clear(); 
  
   //read txstat value of address 256
  txstat = EEPROM.read(256);
  //write  txstat value of address 256
  EEPROM.write(256,txstat);
  
  Serial.begin(9600);
  Serial.println(EEPROM.read(256));
  
  
  //Print character and icons
  
  lcd.createChar(0, sp);
  lcd.createChar(1, on_left);
  lcd.createChar(2, on_right);
  lcd.createChar(3, off_left);
  lcd.createChar(4, off_right);
  lcd.createChar(5, mic);
  lcd.createChar(6, key);
  lcd.createChar(7, ptt);
  
  
  // Print a welcome message to the LCD.
  lcd.setCursor(0, 0); 
  lcd.print("ICOM Station Manager");
  lcd.setCursor(2, 2);   
  lcd.print("firmware by DM2RM");
  lcd.setCursor(4, 3);
  lcd.print("V1.15 07/2017");
  
      { lcd.noBacklight();
      delay(500);
      lcd.backlight();
      delay(500);}
  delay (2000);
  
  lcd.clear();
  lcd.setCursor(2, 0);   
  lcd.print("press UP or DOWN");
  lcd.setCursor(5, 1);   
  lcd.print("to select");
  lcd.setCursor(1, 3);   
  lcd.print("Mic, Key, PTT & SP");
  
     { lcd.noBacklight();
     delay(500);
     lcd.backlight();
     delay(500);} 
  delay (3500);
  
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("********************");
  lcd.setCursor(1, 1);   
  lcd.print("read last settings");
  lcd.setCursor(4, 2);   
  lcd.print("please wait!");
  lcd.setCursor(0, 3);
  lcd.print("********************");
  
     { lcd.noBacklight();
     delay(500);
     lcd.backlight();
     delay(1000);}
  delay (1500);
  lcd.clear(); 
     { lcd.noBacklight();
     delay(500);
     lcd.backlight();
  delay(1000);}
}

void loop() {

 
   // print screen template

  // Upper row 
  {
  lcd.setCursor(5, 0);
  lcd.write(5); 
  lcd.setCursor(6, 0);
  lcd.print("1");
  lcd.setCursor(8, 0);
  lcd.write(5); 
  lcd.setCursor(9, 0);
  lcd.print("2");
  lcd.setCursor(11, 0);  
  lcd.write(6);
  lcd.setCursor(14, 0);
  lcd.write(7);
  lcd.setCursor(17, 0);
  lcd.write(0);
  lcd.setCursor(18, 0);
  lcd.print("<");
  
  // TX column
  lcd.setCursor(0, 1);
  lcd.print("TX1"); 
  lcd.setCursor(0, 2);
  lcd.print("--------------------"); 
  lcd.setCursor(0, 3);
  lcd.print("TX2"); 
  lcd.setCursor(3, 1);  
  lcd.write(char(126));
  lcd.setCursor(3, 3);
  lcd.write(char(126));
  
   
  }

  
  buttonState = digitalRead(downbutton);
    if (buttonState == LOW){
          ButtonTime = millis ();
          buttonpressed = 1;
    if (txstat >= 9) txstat = 0;
    else txstat++; 
    delay (500);
    EEPROM.write(256, txstat); //write txstat to address 256
}    
   buttonState = digitalRead(upbutton);
    if (buttonState == LOW){
          ButtonTime = millis ();
          buttonpressed = 1;
    if (txstat <= 0) txstat = 9;
    else txstat --; 
    delay (500);
    EEPROM.write(256, txstat); //write txstat to address 256
}

  if (txstat == 0) {                  //LOW is TX1 and HIGH is TX2
     digitalWrite(Mic1, LOW);  
     digitalWrite(Mic2, LOW);  
     digitalWrite(Key, LOW);  
     digitalWrite(PTTin, LOW);  
     digitalWrite(AUX, LOW);  
     
//     lcd.setCursor(0, 0);      //enable for programming
//     lcd.print("P1");
 

//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(1); 
    lcd.setCursor(6, 1);
    lcd.write(2);
    lcd.setCursor(8, 1);
    lcd.write(1); 
    lcd.setCursor(9, 1);
    lcd.write(2);
    lcd.setCursor(11, 1);
    lcd.write(1); 
    lcd.setCursor(12, 1);
    lcd.write(2);
    lcd.setCursor(14, 1);
    lcd.write(1); 
    lcd.setCursor(15, 1);
    lcd.write(2);
    lcd.setCursor(17, 1);
    lcd.write(1); 
    lcd.setCursor(18, 1);
    lcd.write(2);

    
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(3); 
    lcd.setCursor(6, 3);
    lcd.write(4);
    lcd.setCursor(8, 3);
    lcd.write(3); 
    lcd.setCursor(9, 3);
    lcd.write(4);
    lcd.setCursor(11, 3);
    lcd.write(3); 
    lcd.setCursor(12, 3);
    lcd.write(4);
    lcd.setCursor(14, 3);
    lcd.write(3); 
    lcd.setCursor(15, 3);
    lcd.write(4);
    lcd.setCursor(17, 3);
    lcd.write(3); 
    lcd.setCursor(18, 3);
    lcd.write(4);
    
  }
  
  
  else if (txstat == 1) {
     digitalWrite(Mic1, HIGH);  
     digitalWrite(Mic2, HIGH);  
     digitalWrite(Key, HIGH);  
     digitalWrite(PTTin, HIGH);  
     digitalWrite(AUX, HIGH);  

//    lcd.setCursor(0, 0);   //enable for programming
//    lcd.print("P2");     
     
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(3); 
    lcd.setCursor(6, 1);
    lcd.write(4);
    lcd.setCursor(8, 1);
    lcd.write(3); 
    lcd.setCursor(9, 1);
    lcd.write(4);
    lcd.setCursor(11, 1);
    lcd.write(3); 
    lcd.setCursor(12, 1);
    lcd.write(4);
    lcd.setCursor(14, 1);
    lcd.write(3); 
    lcd.setCursor(15, 1);
    lcd.write(4); 
    lcd.setCursor(17, 1);
    lcd.write(3); 
    lcd.setCursor(18, 1);
    lcd.write(4);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(1); 
    lcd.setCursor(6, 3);
    lcd.write(2);
    lcd.setCursor(8, 3);
    lcd.write(1); 
    lcd.setCursor(9, 3);
    lcd.write(2);
    lcd.setCursor(11, 3);
    lcd.write(1); 
    lcd.setCursor(12, 3);
    lcd.write(2);
    lcd.setCursor(14, 3);
    lcd.write(1); 
    lcd.setCursor(15, 3);
    lcd.write(2);
    lcd.setCursor(17, 3);
    lcd.write(1); 
    lcd.setCursor(18, 3);
    lcd.write(2);
  }
 
   if (txstat == 2) {                  //LOW is TX1 and HIGH is TX2
     digitalWrite(Mic1, LOW);  
     digitalWrite(Mic2, LOW);  
     digitalWrite(Key, LOW);  
     digitalWrite(PTTin, LOW);  
     digitalWrite(AUX, HIGH);  
     
//    lcd.setCursor(0, 0);      //enable for programming
//    lcd.print("P3");

//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(1); 
    lcd.setCursor(6, 1);
    lcd.write(2);
    lcd.setCursor(8, 1);
    lcd.write(1); 
    lcd.setCursor(9, 1);
    lcd.write(2);
    lcd.setCursor(11, 1);
    lcd.write(1); 
    lcd.setCursor(12, 1);
    lcd.write(2);
    lcd.setCursor(14, 1);
    lcd.write(1); 
    lcd.setCursor(15, 1);
    lcd.write(2);
    lcd.setCursor(17, 1);
    lcd.write(3); 
    lcd.setCursor(18, 1);
    lcd.write(4);
    
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(3); 
    lcd.setCursor(6, 3);
    lcd.write(4);
    lcd.setCursor(8, 3);
    lcd.write(3); 
    lcd.setCursor(9, 3);
    lcd.write(4);
    lcd.setCursor(11, 3);
    lcd.write(3); 
    lcd.setCursor(12, 3);
    lcd.write(4);
    lcd.setCursor(14, 3);
    lcd.write(3); 
    lcd.setCursor(15, 3);
    lcd.write(4);
    lcd.setCursor(17, 3);
    lcd.write(1); 
    lcd.setCursor(18, 3);
    lcd.write(2);
    
  } 
  
    else if (txstat == 3) {
     digitalWrite(Mic1, HIGH);  
     digitalWrite(Mic2, HIGH);  
     digitalWrite(Key, HIGH);  
     digitalWrite(PTTin, HIGH);  
     digitalWrite(AUX, LOW);  

//    lcd.setCursor(0, 0);   //enable for programming
//    lcd.print("P4");     
     
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(3); 
    lcd.setCursor(6, 1);
    lcd.write(4);
    lcd.setCursor(8, 1);
    lcd.write(3); 
    lcd.setCursor(9, 1);
    lcd.write(4);
    lcd.setCursor(11, 1);
    lcd.write(3); 
    lcd.setCursor(12, 1);
    lcd.write(4);
    lcd.setCursor(14, 1);
    lcd.write(3); 
    lcd.setCursor(15, 1);
    lcd.write(4); 
    lcd.setCursor(17, 1);
    lcd.write(1); 
    lcd.setCursor(18, 1);
    lcd.write(2);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(1); 
    lcd.setCursor(6, 3);
    lcd.write(2);
    lcd.setCursor(8, 3);
    lcd.write(1); 
    lcd.setCursor(9, 3);
    lcd.write(2);
    lcd.setCursor(11, 3);
    lcd.write(1); 
    lcd.setCursor(12, 3);
    lcd.write(2);
    lcd.setCursor(14, 3);
    lcd.write(1); 
    lcd.setCursor(15, 3);
    lcd.write(2);
    lcd.setCursor(17, 3);
    lcd.write(3); 
    lcd.setCursor(18, 3);
    lcd.write(4);
  }
  
  else if (txstat == 4) {
     digitalWrite(Mic1, HIGH);  
     digitalWrite(Mic2, HIGH);  
     digitalWrite(Key, LOW);  
     digitalWrite(PTTin, HIGH);  
     digitalWrite(AUX, HIGH);  
     
//    lcd.setCursor(0, 0);    //enable for programming
//    lcd.print("P5");
     
 //TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(3); 
    lcd.setCursor(6, 1);
    lcd.write(4);
    lcd.setCursor(8, 1);
    lcd.write(3); 
    lcd.setCursor(9, 1);
    lcd.write(4);
    lcd.setCursor(11, 1);
    lcd.write(1);
    lcd.setCursor(12, 1);
    lcd.write(2);
    lcd.setCursor(14, 1);
    lcd.write(3); 
    lcd.setCursor(15, 1);
    lcd.write(4); 
    lcd.setCursor(17, 1);
    lcd.write(3); 
    lcd.setCursor(18, 1);
    lcd.write(4);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(1); 
    lcd.setCursor(6, 3);
    lcd.write(2);
    lcd.setCursor(8, 3);
    lcd.write(1); 
    lcd.setCursor(9, 3);
    lcd.write(2);
    lcd.setCursor(11, 3);
    lcd.write(3); 
    lcd.setCursor(12, 3);
    lcd.write(4);
    lcd.setCursor(14, 3);
    lcd.write(1); 
    lcd.setCursor(15, 3);
    lcd.write(2);
    lcd.setCursor(17, 3);
    lcd.write(1); 
    lcd.setCursor(18, 3);
    lcd.write(2);
  }
 
       
     else if (txstat == 5) {
     digitalWrite(Mic1, LOW);  
     digitalWrite(Mic2, LOW);  
     digitalWrite(Key, HIGH);  
     digitalWrite(PTTin, LOW);  
     digitalWrite(AUX, LOW);  
     
//    lcd.setCursor(0, 0);    //enable for programming
//    lcd.print("P6");


//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(1); 
    lcd.setCursor(6, 1);
    lcd.write(2);
    lcd.setCursor(8, 1);
    lcd.write(1); 
    lcd.setCursor(9, 1);
    lcd.write(2);
    lcd.setCursor(11, 1);
    lcd.write(3); 
    lcd.setCursor(12, 1);
    lcd.write(4);
    lcd.setCursor(14, 1);
    lcd.write(1); 
    lcd.setCursor(15, 1);
    lcd.write(2);
    lcd.setCursor(17, 1);
    lcd.write(1); 
    lcd.setCursor(18, 1);
    lcd.write(2);

 //TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(3); 
    lcd.setCursor(6, 3);
    lcd.write(4);
    lcd.setCursor(8, 3);
    lcd.write(3); 
    lcd.setCursor(9, 3);
    lcd.write(4);
    lcd.setCursor(11, 3);
    lcd.write(1);
    lcd.setCursor(12, 3);
    lcd.write(2);
    lcd.setCursor(14, 3);
    lcd.write(3); 
    lcd.setCursor(15, 3);
    lcd.write(4); 
    lcd.setCursor(17, 3);
    lcd.write(3); 
    lcd.setCursor(18, 3);
    lcd.write(4);

  }
  
     else if (txstat == 6) {
     digitalWrite(Mic1, HIGH);  
     digitalWrite(Mic2, LOW);  
     digitalWrite(Key, LOW);  
     digitalWrite(PTTin, HIGH);  
     digitalWrite(AUX, HIGH);  
     
//    lcd.setCursor(0, 0);    //enable for programming
//    lcd.print("P7");
 
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(3); 
    lcd.setCursor(6, 1);
    lcd.write(4);
    lcd.setCursor(8, 1);
    lcd.write(1); 
    lcd.setCursor(9, 1);
    lcd.write(2);
    lcd.setCursor(11, 1);
    lcd.write(1); 
    lcd.setCursor(12, 1);
    lcd.write(2);
    lcd.setCursor(14, 1);
    lcd.write(3); 
    lcd.setCursor(15, 1);
    lcd.write(4);
    lcd.setCursor(17, 1);
    lcd.write(3); 
    lcd.setCursor(18, 1);
    lcd.write(4);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(1); 
    lcd.setCursor(6, 3);
    lcd.write(2);
    lcd.setCursor(8, 3);
    lcd.write(3); 
    lcd.setCursor(9, 3);
    lcd.write(4);
    lcd.setCursor(11, 3);
    lcd.write(3); 
    lcd.setCursor(12, 3);
    lcd.write(4);
    lcd.setCursor(14, 3);
    lcd.write(1); 
    lcd.setCursor(15, 3);
    lcd.write(2);
    lcd.setCursor(17, 3);
    lcd.write(1); 
    lcd.setCursor(18, 3);
    lcd.write(2);

  }
  
  
     else if (txstat == 7) {
     digitalWrite(Mic1, LOW);  
     digitalWrite(Mic2, HIGH);  
     digitalWrite(Key, HIGH);  
     digitalWrite(PTTin, LOW);  
     digitalWrite(AUX, LOW);  
     
    lcd.setCursor(0, 0);
    lcd.print("P8");
     
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(1); 
    lcd.setCursor(6, 1);
    lcd.write(2);
    lcd.setCursor(8, 1);
    lcd.write(3); 
    lcd.setCursor(9, 1);
    lcd.write(4);
    lcd.setCursor(11, 1);
    lcd.write(3); 
    lcd.setCursor(12, 1);
    lcd.write(4);
    lcd.setCursor(14, 1);
    lcd.write(1); 
    lcd.setCursor(15, 1);
    lcd.write(2);
    lcd.setCursor(17, 1);
    lcd.write(1); 
    lcd.setCursor(18, 1);
    lcd.write(2);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(3); 
    lcd.setCursor(6, 3);
    lcd.write(4);
    lcd.setCursor(8, 3);
    lcd.write(1); 
    lcd.setCursor(9, 3);
    lcd.write(2);
    lcd.setCursor(11, 3);
    lcd.write(1); 
    lcd.setCursor(12, 3);
    lcd.write(2);
    lcd.setCursor(14, 3);
    lcd.write(3); 
    lcd.setCursor(15, 3);
    lcd.write(4);
    lcd.setCursor(17, 3);
    lcd.write(3); 
    lcd.setCursor(18, 3);
    lcd.write(4);
    }
 
      else if (txstat == 8) {
     digitalWrite(Mic1, HIGH);  
     digitalWrite(Mic2, LOW);  
     digitalWrite(Key, HIGH);  
     digitalWrite(PTTin, LOW);  
     digitalWrite(AUX, LOW);  
     
//    lcd.setCursor(0, 0);    //enable for programming
//    lcd.print("P9");
 
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(3); 
    lcd.setCursor(6, 1);
    lcd.write(4);
    lcd.setCursor(8, 1);
    lcd.write(1); 
    lcd.setCursor(9, 1);
    lcd.write(2);
    lcd.setCursor(11, 1);
    lcd.write(3); 
    lcd.setCursor(12, 1);
    lcd.write(4);
    lcd.setCursor(14, 1);
    lcd.write(1); 
    lcd.setCursor(15, 1);
    lcd.write(2);
    lcd.setCursor(17, 1);
    lcd.write(1); 
    lcd.setCursor(18, 1);
    lcd.write(2);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(1); 
    lcd.setCursor(6, 3);
    lcd.write(2);
    lcd.setCursor(8, 3);
    lcd.write(3); 
    lcd.setCursor(9, 3);
    lcd.write(4);
    lcd.setCursor(11, 3);
    lcd.write(1); 
    lcd.setCursor(12, 3);
    lcd.write(2);
    lcd.setCursor(14, 3);
    lcd.write(3); 
    lcd.setCursor(15, 3);
    lcd.write(4);
    lcd.setCursor(17, 3);
    lcd.write(3); 
    lcd.setCursor(18, 3);
    lcd.write(4);

  }
  
  
     else if (txstat == 9) {
     digitalWrite(Mic1, LOW);  
     digitalWrite(Mic2, HIGH);  
     digitalWrite(Key, LOW);  
     digitalWrite(PTTin, HIGH);  
     digitalWrite(AUX, HIGH);  
     
//    lcd.setCursor(0, 0);
//    lcd.print("P10");
     
//TX1 selection    
    lcd.setCursor(5, 1);
    lcd.write(1); 
    lcd.setCursor(6, 1);
    lcd.write(2);
    lcd.setCursor(8, 1);
    lcd.write(3); 
    lcd.setCursor(9, 1);
    lcd.write(4);
    lcd.setCursor(11, 1);
    lcd.write(1); 
    lcd.setCursor(12, 1);
    lcd.write(2);
    lcd.setCursor(14, 1);
    lcd.write(3); 
    lcd.setCursor(15, 1);
    lcd.write(4);
    lcd.setCursor(17, 1);
    lcd.write(3); 
    lcd.setCursor(18, 1);
    lcd.write(4);
    
//TX2 selection    
    lcd.setCursor(5, 3);
    lcd.write(3); 
    lcd.setCursor(6, 3);
    lcd.write(4);
    lcd.setCursor(8, 3);
    lcd.write(1); 
    lcd.setCursor(9, 3);
    lcd.write(2);
    lcd.setCursor(11, 3);
    lcd.write(3); 
    lcd.setCursor(12, 3);
    lcd.write(4);
    lcd.setCursor(14, 3);
    lcd.write(1); 
    lcd.setCursor(15, 3);
    lcd.write(2);
    lcd.setCursor(17, 3);
    lcd.write(1); 
    lcd.setCursor(18, 3);
    lcd.write(2);
    }
  
}

